<?php

require_once dirname(__FILE__).'/../lib/groupeclasseGeneratorConfiguration.class.php';
require_once dirname(__FILE__).'/../lib/groupeclasseGeneratorHelper.class.php';

/**
 * groupeclasse actions.
 *
 * @package    abuledu
 * @subpackage groupeclasse
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class groupeclasseActions extends autoGroupeclasseActions
{
       /**
   *  Suppression des utilisateurs en fonction des permissions et domaine
   */
  public function executeDelete(sfWebRequest $request)
  {
    $this->tbl_groupe = $this->getRoute()->getObject();

    $oUser = $this->getUser();
    $nDomaine =  $oUser->getDomaine();
     //cas super admin
    if ($oUser->hasCredential('admin')) {

      //cas admin domaine
    } elseif ($oUser->hasCredential('admin_domaine')) {
      if ($this->tbl_groupe->getIdDomaine() != $nDomaine) {
        $this->redirect('@tbl_groupe');
      }
      //cas resp groupe
    } else {
      $this->redirect('@tbl_groupe');
    }
    parent::executeDelete($request);
  }

  /**
   *  Edition des utilisateurs en fonction des permissions et domaine
   */
  public function executeEdit(sfWebRequest $request)
  {
    $this->tbl_groupe = $this->getRoute()->getObject();
    $oUser = $this->getUser();
    $nDomaine =  $oUser->getDomaine();
     //cas super admin
    if ($oUser->hasCredential('admin')) {

      //cas admin domaine
    } elseif ($oUser->hasCredential('admin_domaine')) {
      if ($this->tbl_groupe->getIdDomaine() != $nDomaine) {
        $this->redirect('@tbl_groupe');
      }
      //cas resp groupe
    } else {
      $this->redirect('@tbl_groupe');
    }
    $this->form = $this->configuration->getForm($this->tbl_groupe);
  }
  protected function processForm(sfWebRequest $request, sfForm $form)
  {
    $form->bind($request->getParameter($form->getName()), $request->getFiles($form->getName()));
    if ($form->isValid())
    {
      $notice = $form->getObject()->isNew() ? 'The item was created successfully.' : 'The item was updated successfully.';

      try {
        $tbl_groupe = $form->save();
        if (!$this->getUser()->isSuperAdmin()) {
            $oNewUser = Doctrine::getTable('tbl_groupe')->find($tbl_groupe->getId());
            $oNewUser->setIdDomaine($this->getUser()->getDomaine());
            $oNewUser->save();
        }
      } catch (Doctrine_Validator_Exception $e) {

        $errorStack = $form->getObject()->getErrorStack();

        $message = get_class($form->getObject()) . ' has ' . count($errorStack) . " field" . (count($errorStack) > 1 ?  's' : null) . " with validation errors: ";
        foreach ($errorStack as $field => $errors) {
            $message .= "$field (" . implode(", ", $errors) . "), ";
        }
        $message = trim($message, ', ');

        $this->getUser()->setFlash('error', $message);
        return sfView::SUCCESS;
      }

      $this->dispatcher->notify(new sfEvent($this, 'admin.save_object', array('object' => $tbl_groupe)));

      if ($request->hasParameter('_save_and_add'))
      {
        $this->getUser()->setFlash('notice', $notice.' You can add another one below.');

        $this->redirect('@tbl_groupe_new');
      }
      else
      {
        $this->getUser()->setFlash('notice', $notice);

        $this->redirect(array('sf_route' => 'tbl_groupe_edit', 'sf_subject' => $tbl_groupe));
      }
    }
    else
    {
      $this->getUser()->setFlash('error', 'The item has not been saved due to some errors.', false);
    }
  }

}
