<?php

require_once dirname(__FILE__).'/../lib/sfGuardUserGeneratorConfiguration.class.php';
require_once dirname(__FILE__).'/../lib/sfGuardUserGeneratorHelper.class.php';

/**
 * sfGuardUser actions.
 *
 * @package    sfGuardPlugin
 * @subpackage sfGuardUser
 * @author     Fabien Potencier
 * @version    SVN: $Id: actions.class.php 23319 2009-10-25 12:22:23Z Kris.Wallsmith $
 */
class sfGuardUserActions extends autoSfGuardUserActions
{
   /**
   *  Suppression des utilisateurs en fonction des permissions et domaine
   */
  public function executeDelete(sfWebRequest $request)
  {
    $this->sf_guard_user = $this->getRoute()->getObject();

    $oUser = $this->getUser();
    $nDomaine =  $oUser->getDomaine();
     //cas super admin
    if ($oUser->hasCredential('admin')) {

      //cas admin domaine
    } elseif ($oUser->hasCredential('admin_domaine')) {
      if ($this->sf_guard_user->getIdDomaine() != $nDomaine) {
        $this->redirect('@sf_guard_user');
      }
      //cas resp groupe
    } else {
      $this->redirect('@sf_guard_user');
    }
    parent::executeDelete($request);
  }

  /**
   *  Edition des utilisateurs en fonction des permissions et domaine
   */
  public function executeEdit(sfWebRequest $request)
  {
    $this->sf_guard_user = $this->getRoute()->getObject();
    $oUser = $this->getUser();
    $nDomaine =  $oUser->getDomaine();
     //cas super admin
    if ($oUser->hasCredential('admin')) {

      //cas admin domaine
    } elseif ($oUser->hasCredential('admin_domaine')) {
      if ($this->sf_guard_user->getIdDomaine() != $nDomaine) {
        $this->redirect('@sf_guard_user');
      }
      //cas resp groupe
    } else {
      $this->redirect('@sf_guard_user');
    }
    $this->form = $this->configuration->getForm($this->sf_guard_user);
  }
  protected function processForm(sfWebRequest $request, sfForm $form)
  {
    $form->bind($request->getParameter($form->getName()), $request->getFiles($form->getName()));
    if ($form->isValid())
    {
      $notice = $form->getObject()->isNew() ? 'The item was created successfully.' : 'The item was updated successfully.';

      try {        
        $sf_guard_user = $form->save();
        if (!$this->getUser()->isSuperAdmin()) {
            $oNewUser = Doctrine::getTable('sfGuardUser')->find($sf_guard_user->getId());
            $oNewUser->setIdDomaine($this->getUser()->getDomaine());
            $oNewUser->save();
        }
      } catch (Doctrine_Validator_Exception $e) {

        $errorStack = $form->getObject()->getErrorStack();

        $message = get_class($form->getObject()) . ' has ' . count($errorStack) . " field" . (count($errorStack) > 1 ?  's' : null) . " with validation errors: ";
        foreach ($errorStack as $field => $errors) {
            $message .= "$field (" . implode(", ", $errors) . "), ";
        }
        $message = trim($message, ', ');

        $this->getUser()->setFlash('error', $message);
        return sfView::SUCCESS;
      }

      $this->dispatcher->notify(new sfEvent($this, 'admin.save_object', array('object' => $sf_guard_user)));

      if ($request->hasParameter('_save_and_add'))
      {
        $this->getUser()->setFlash('notice', $notice.' You can add another one below.');

        $this->redirect('@sf_guard_user_new');
      }
      else
      {
        $this->getUser()->setFlash('notice', $notice);

        $this->redirect(array('sf_route' => 'sf_guard_user_edit', 'sf_subject' => $sf_guard_user));
      }
    }
    else
    {
      $this->getUser()->setFlash('error', 'The item has not been saved due to some errors.', false);
    }
  }
}
